﻿Public Class frmPose


    Private Sub updnPositionX_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles updnLocationX.ValueChanged
        Try
            If Not Me.InvokeRequired Then
                If updnLocationX.Focused Then
                    updnLocationX.Enabled = False
                    subChangeParticlePose(updnLocationX.Value - tbpBotPose.Location.X, 0, 0)
                    tbpBotPose.Location.X = updnLocationX.Value
                    If Not boolDrivingToDestination Then GotABotClass.subRedraw(tbpBotPose)
                    updnLocationX.Enabled = True
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in updnPositionX_ValueChanged")
        End Try
    End Sub

 
    Private Sub updnPositionY_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles updnLocationY.ValueChanged
        Try
            If Not Me.InvokeRequired Then
                If updnLocationY.Focused Then
                    updnLocationY.Enabled = False
                    subChangeParticlePose(0, updnLocationY.Value - tbpBotPose.Location.Y, 0)
                    tbpBotPose.Location.Y = updnLocationY.Value
                    If Not boolDrivingToDestination Then GotABotClass.subRedraw(tbpBotPose)
                    updnLocationY.Enabled = True
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in updnPositionY_ValueChanged")
        End Try
    End Sub

    Private Sub updnOrientation_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles updnOrientation.ValueChanged
        Try
            If Not Me.InvokeRequired Then
                If updnOrientation.Focused Then
                    updnOrientation.Enabled = False
                    subChangeParticlePose(0, 0, ftnAngleDifference(Convert.ToInt16(updnOrientation.Value), tbpBotPose.Orientation))
                    frmDebug.subWriteLogs(Color.Black, " ************  New Bot Orientation selected:  = " & updnOrientation.Value & " Degrees")
                    tbpBotPose.Orientation = ftnConvertTo360(Convert.ToInt16(updnOrientation.Value))
                    updnOrientation.Value = tbpBotPose.Orientation
                    tbpTargetPoseGlobal = tbpBotPose
                    If Not boolDrivingToDestination Then GotABotClass.subRedraw(tbpBotPose)
                    updnOrientation.Enabled = True
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in updnOrientation_ValueChanged")
        End Try
    End Sub

     Private Sub updnUncertaintyX_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles updnUncertaintyX.ValueChanged
        Try
            If Not Me.InvokeRequired Then
                If updnUncertaintyX.Focused Then
                    updnUncertaintyX.Enabled = False
                    tbpBotPose.LocationUncertainty.X = updnUncertaintyX.Value
                    If Not boolDrivingToDestination Then GotABotClass.subRedraw(tbpBotPose)
                    updnUncertaintyX.Enabled = True
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in updnUncertaintyX_ValueChanged")
        End Try
    End Sub

     Private Sub updnUncertaintyY_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles updnUncertaintyY.ValueChanged
        Try
            If Not Me.InvokeRequired Then
                If updnUncertaintyY.Focused Then
                    updnUncertaintyY.Enabled = False
                    tbpBotPose.LocationUncertainty.Y = updnUncertaintyY.Value
                    If Not boolDrivingToDestination Then GotABotClass.subRedraw(tbpBotPose)
                    updnUncertaintyY.Enabled = True
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in updnUncertaintyY_ValueChanged")
        End Try
    End Sub

    Private Sub updnOrientationUncertainty_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles updnOrientationUncertainty.ValueChanged
        Try
            If Not Me.InvokeRequired Then
                If updnOrientationUncertainty.Focused Then
                    updnOrientationUncertainty.Enabled = False
                    tbpBotPose.OrientationUncertainty = updnOrientationUncertainty.Value
                    If Not boolDrivingToDestination Then GotABotClass.subRedraw(tbpBotPose)
                    updnOrientationUncertainty.Enabled = True
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in updnOrientationUncertainty_ValueChanged")
        End Try
    End Sub

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        Me.Visible = False
        GotABotClass.subRedraw(tbpBotPose)
        Me.Close()
    End Sub


End Class