﻿' scan 360 degrees and look for landmarks in order to localize
Imports System.Math
' Imports Microsoft.Kinect


Module modLocalizeLost

    Public Function ftnLostRecoveryTop(ByVal tbpEstimatedPose As typeBotPose) As typeBotPose
        Try
            ftnLostRecoveryTop = tbpEstimatedPose
            If ftnIAmLost(tbpEstimatedPose) And Not boolStop And Not boolShutDown Then
                If boolHeroSelected Then
                    ftnLostRecoveryTop.OrientationUncertainty += 10
                    ftnLostRecoveryTop.LocationUncertainty.X += sngTenInchesGrid
                    ftnLostRecoveryTop.LocationUncertainty.Y += sngTenInchesGrid
                    ftnLostRecoveryTop = ftnGetUnStuck(ftnLostRecoveryTop, "Fwd")
                    Dim boolGoodLocalization As Boolean = False
                    ftnLostRecoveryTop = ftnLocalize_Top(tbpEstimatedPose, boolGoodLocalization)
                Else
                    ftnLostRecoveryTop.OrientationUncertainty = 60
                    ftnLostRecoveryTop.LocationUncertainty.X = sngfortyInches / sngGridSize
                    ftnLostRecoveryTop.LocationUncertainty.Y = ftnLostRecoveryTop.LocationUncertainty.X
                    ftnLostRecoveryTop = ftnLostRecovery(ftnLostRecoveryTop)
                    If ftnIAmLost(ftnLostRecoveryTop) And Not boolStop And Not boolShutDown Then
                        subWait(1500)
                        ftnLostRecoveryTop.OrientationUncertainty = 140
                        ftnLostRecoveryTop.LocationUncertainty.X = sngSixtyFiveInches / sngGridSize
                        ftnLostRecoveryTop.LocationUncertainty.Y = ftnLostRecoveryTop.LocationUncertainty.X
                        ftnLostRecoveryTop = ftnLostRecovery(ftnLostRecoveryTop)
                    End If
                    If ftnIAmLost(ftnLostRecoveryTop) And Not boolStop And Not boolShutDown Then
                        subWait(1500)
                        ftnLostRecoveryTop.OrientationUncertainty = 170
                        ftnLostRecoveryTop.LocationUncertainty.X = ftnInchesToMapUnits(120) / sngGridSize
                        ftnLostRecoveryTop.LocationUncertainty.Y = ftnLostRecoveryTop.LocationUncertainty.X
                        ftnLostRecoveryTop = ftnLostRecovery(ftnLostRecoveryTop)
                    End If
                    If ftnIAmLost(ftnLostRecoveryTop) And Not boolStop And Not boolShutDown Then
                        frmDebug.subWriteLogs(Color.Red, intDrivingSequenceNumber & " : HELP!  I'm lost - ")
                        strStatusDriving = intDrivingSequenceNumber & " : HELP!  I'm lost -"
                        If Not boolStop Then ftnSendCommand("play phrase 'I give up'")
                        boolDrivingToDestination = False
                        boolStop = True
                        GotABotClass.subUpdateAllText(ftnLostRecoveryTop)
                    ElseIf Not boolStop Then
                        If Not boolStop Then ftnSendCommand("play phraseA 'Ok. I know where I am.'")
                    End If
                End If

            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnLostRecoveryTop")
        End Try
    End Function

    Public Function ftnIAmLost(ByVal tbpEstimatedPose As typeBotPose) As Boolean
        ftnIAmLost = False
        If Not boolSlam Then
            If ((ftnPoseUncertaintyFactor(tbpEstimatedPose) > 1200) _
            Or (tbpEstimatedPose.OrientationUncertainty > 40) _
            Or ((ftnMapUnitsToInches(tbpEstimatedPose.LocationUncertainty.X + tbpEstimatedPose.LocationUncertainty.Y) * sngGridSize) > 50)) Then
                ftnIAmLost = True
            Else
                ftnIAmLost = False
            End If
        End If
    End Function


    Private Function ftnLostRecovery(ByVal tbpEstimatedPose As typeBotPose) As typeBotPose   'Rotate 360 degrees in steps and attempt to localize
        ftnLostRecovery = tbpEstimatedPose
        Try
            ftnLostRecovery = tbpEstimatedPose
            If Not boolStop Then
                tbpTargetPoseGlobal = ftnLostRecovery
                'Dim boolCollisionDetectionEnable_Temp As Boolean = boolCollisionDetectionEnable
                Dim intMaxLostTurns As Short
                Dim boolGoodLocalization As Boolean = False
                Dim intTurnAngle As Short
                If ftnScannerEnabled() Then
                    intMaxLostTurns = 360 / sngScanFOV
                    intTurnAngle = sngScanFOV
                Else
                    intMaxLostTurns = 360 / sngCameraFOV
                    intTurnAngle = sngCameraFOV
                End If
                boolPoseConfirmedAfterCollision = True
                ftnSendCommand("play phraseA 'i am lost'")
                frmDebug.subWriteLogs(Color.Red, "@@@@@@@@@@@@@@@@ I'm lost, Attempting recovery........@@@@@@@@@@@@@@@@@@ ")
                ftnLostRecovery = frmCompass.ftnLocalizeUsingCompass(tbpEstimatedPose)
                ftnLostRecovery = ftnGetUnStuck(ftnLostRecovery, "Fwd")
                ftnLostRecovery.OrientationUncertainty = tbpEstimatedPose.OrientationUncertainty
                Dim intTurn As Short = 0
                Do While (ftnIAmLost(ftnLostRecovery) And (intTurn < intMaxLostTurns) And Not (GotABotClass.picStop.BorderStyle = FormBorderStyle.Fixed3D) _
                          And (boolDrivingToDestination Or boolDock))
                    subCheckForPause()
                    ftnLostRecovery.LocationUncertainty = tbpEstimatedPose.LocationUncertainty
                    ftnLostRecovery.OrientationUncertainty = tbpEstimatedPose.OrientationUncertainty
                    tbpTargetPoseGlobal = ftnLostRecovery
                    subDoEventsIfMainThread()
                    GotABotClass.subRedraw(ftnLostRecovery)
                    ftnLostRecovery = ftnLocalize_Top(ftnLostRecovery, boolGoodLocalization)
                    ftnLostRecovery = ftnRefineLocalization(ftnLostRecovery)

                    If ftnIAmLost(ftnLostRecovery) And Not boolStop And boolDrivingToDestination Then
                        tbpTargetPoseGlobal.Orientation = ftnConvertTo360(ftnLostRecovery.Orientation + intTurnAngle)
                        ftnLostRecovery = ftnBotTurn(ftnLostRecovery, False, tbpTargetPoseGlobal)
                        subWait(500)
                        If ftnAmIStuck(ftnLostRecovery, "Turn", intTurnAngle) Then ftnLostRecovery = ftnGetUnStuck(ftnLostRecovery, "Turn")
                        If (ftnCheckForCollision()) Then ftnLostRecovery = ftnCollisionRecovery(ftnLostRecovery)
                        intTurn += 1
                    ElseIf ftnIAmLost(ftnLostRecovery) And Not boolStop And boolDock Then
                        Dim tbpTargetPose As typeBotPose = tbpEstimatedPose
                        If boolDockBackIn Then
                            tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, sngSixInches)
                        Else
                            tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 180, sngFourInches + sngBotRadius)
                        End If
                        ftnLostRecovery = ftnBotFwd(tbpEstimatedPose, tbpTargetPose)  '  
                        intMovementsSinceLocalization = 99  'Force Localization
                        ftnLostRecovery = ftnPostMovement(tbpTargetPose, "Fwd", tbpTargetPose)
                    End If
                Loop
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnLostRecovery")
        End Try
    End Function

    Function ftnRefineLocalization(ByVal tbpEstimatedPose As typeBotPose) As typeBotPose
        Try
            ftnRefineLocalization = tbpEstimatedPose
            If ftnVisualRecognizerEnabled() And Not boolStop Then
                Dim boolGoodLocalization As Boolean = False
                For I As Integer = 1 To 3
                    If (ftnRefineLocalization.OrientationUncertainty > 20) And (ftnRefineLocalization.OrientationUncertainty < 55) And Not boolStop Then
                        ftnRefineLocalization = ftnLocalize_Top(ftnRefineLocalization, boolGoodLocalization)
                        frmDebug.subWritePoseIfVerbose(" ftnLostRecovery - Refinement :  Bot Pose after Localization", ftnRefineLocalization)
                        GotABotClass.subRedraw(ftnRefineLocalization)
                    End If
                Next
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnRefineLocalization")
        End Try
    End Function


End Module
