﻿
Imports System.Threading

Public Module modThreadControl




    '==================================== THREADS   =============================================

    Public Sub Start_Threads()
        Try
            classNewER1Client = New classER1Client()
            Dim ER1ClientMainThread As New Thread(AddressOf classNewER1Client.subMain)
            ER1ClientMainThread.IsBackground = True
            ER1ClientMainThread.Start()

            classNewAPI1Server = New classAPI1Server()
            Dim API1MainThread As New Thread(AddressOf classAPI1Server.subMain)
            API1MainThread.IsBackground = True
            API1MainThread.Start()

            classNewAPI2Server = New classAPI2Server()
            Dim API2MainThread As New Thread(AddressOf classAPI2Server.subMain)
            API2MainThread.IsBackground = True
            API2MainThread.Start()

            classNewLocalRccClient = New classLRCCClient()
            Dim LocalRccClientMainThread As New Thread(AddressOf classNewLocalRccClient.subMain)
            LocalRccClientMainThread.IsBackground = True
            LocalRccClientMainThread.Start()

            classNewGotAGlyphClient = New classGotAGlyphClient()
            Dim GotAGlyphClientMainThread As New Thread(AddressOf classNewGotAGlyphClient.subMain)
            GotAGlyphClientMainThread.IsBackground = True
            GotAGlyphClientMainThread.Start()

            classNewRoboRealmClient = New classRoboRealmClient()
            Dim RoboRealmClientMainThread As New Thread(AddressOf classNewRoboRealmClient.MainRoboRealm)
            RoboRealmClientMainThread.IsBackground = True
            RoboRealmClientMainThread.Start()

            classNewLocalizeMovingVisual = New classLocalizeMovingVisual()
            Dim LocalizeMovingVisualMainThread As New Thread(AddressOf classNewLocalizeMovingVisual.subLocalizeWhileMovingVisual_Top)
            LocalizeMovingVisualMainThread.IsBackground = True
            LocalizeMovingVisualMainThread.Start()

            evntCourseCorrection = New classCourseCorrection()
            Dim CourseCorrectionThreadObject As New classCourseCorrection()
            Dim CourseCorrectionMainThread As New Thread(AddressOf evntCourseCorrection.subCourseCorrection_Top)
            CourseCorrectionMainThread.IsBackground = True
            CourseCorrectionMainThread.Start()

            classNewObstacleMoving = New classObstacleMoving()
            Dim ObstacleMoving2DscanMainThread As New Thread(AddressOf classNewObstacleMoving.subPreventCollisions)
            ObstacleMoving2DscanMainThread.IsBackground = True
            ObstacleMoving2DscanMainThread.Start()


            classNewAddImageToQueue = New classAddImageToQueue()
            Dim AddImageToQueueMainThread As New Thread(AddressOf classNewAddImageToQueue.subGetMoreRecognizedImages)
            AddImageToQueueMainThread.IsBackground = True
            AddImageToQueueMainThread.Start()

            classNewKinect = New classScanner()   ' why is this a thread?
            Dim KinectThread As New Thread(AddressOf ftnKinectInitializeTop)
            KinectThread.IsBackground = True
            KinectThread.Start()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in Start_Threads")
        End Try
    End Sub


    '==================================== ER1 IF  Thread  =============================================
    Dim WithEvents classNewER1Client As classER1Client

    '==================================== API  Thread  =============================================
    Delegate Sub DelegateevntAPI()
    Dim WithEvents classNewAPI1Server As classAPI1Server

    Sub evntAPI_evntAPICommandReceived(ByVal boolAPICommandReceived As Boolean) Handles classNewAPI1Server.evntAPICommandReceived
        If boolAPICommandReceived Then APICommandReceived()
    End Sub


    Sub APICommandReceived()
        ' If InvokeRequired is true then the call is being made on a thread other
        ' than the UI thread.
        Try
            If GotABotClass.myMap.InvokeRequired And Not boolShutDown Then
                Dim newDelegate As New DelegateevntAPI(AddressOf APICommandReceived)
                GotABotClass.Invoke(newDelegate)
            ElseIf Not boolShutDown Then
                boolAPIActivity1 = True
                API1ParseAndRespond()
            End If ' GotABotClass.InvokeRequired
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in APICommandReceivedp")
        End Try
    End Sub


    '==================================== API2  Thread  =============================================
    'Dim API2MainThread As Thread
    Delegate Sub DelegateevntAPI2()
    Dim WithEvents classNewAPI2Server As classAPI2Server

    Sub evntAPI_evntAPI2CommandReceived(ByVal boolAPICommandReceived As Boolean) Handles classNewAPI2Server.evntAPICommandReceived
        If boolAPICommandReceived Then API2CommandReceived()
    End Sub


    Sub API2CommandReceived()
        ' If InvokeRequired is true then the call is being made on a thread other
        ' than the UI thread.
        Try
            If GotABotClass.InvokeRequired And Not boolShutDown Then
                Dim newDelegate As New DelegateevntAPI2(AddressOf API2CommandReceived)
                GotABotClass.Invoke(newDelegate)
            ElseIf Not boolShutDown Then
                boolAPIActivity2 = True
                API2ParseAndRespond()
            End If ' GotABotClass.InvokeRequired
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in API2CommandReceived")
        End Try
    End Sub

    '==================================== Local RCC Client Thread  =============================================
    Dim WithEvents classNewLocalRccClient As classLRCCClient

    '==================================== GotAGlyph Client Thread  =============================================
    Dim WithEvents classNewGotAGlyphClient As classGotAGlyphClient

    '==================================== RoboRealm Client Thread  =============================================
    Dim WithEvents classNewRoboRealmClient As classRoboRealmClient

    '==================================== Visual Localize Moving Thread  =============================================
    Dim LocalizeMovingVisualMainThread As Thread   '??
    Delegate Sub DelegateevntLocalizeMoving()
    Dim WithEvents classNewLocalizeMovingVisual As classLocalizeMovingVisual


    '==================================== Course Correction Thread  =============================================
    Dim CourseCorrectionThread As Thread   '?? 
    Delegate Sub DelegateevntCourseCorrection()
    Dim WithEvents evntCourseCorrection As classCourseCorrection



    '====================================  Obstacle Moving Thread  =============================================
    Delegate Sub DelegateevntCollisionPredicted()
    Dim WithEvents classNewObstacleMoving As classObstacleMoving

    Sub subCollisionPredictedTop() Handles classNewObstacleMoving.evntCollisionPredicted
        subCollisionPredicted()
    End Sub

    Sub subCollisionPredicted()
        ' If InvokeRequired is true then the call is being made on a thread other
        ' than the UI thread.
        Try
            If GotABotClass.InvokeRequired Then
                Dim newDelegate As New DelegateevntCollisionPredicted(AddressOf subCollisionPredicted)
                GotABotClass.Invoke(newDelegate)
            Else
                If boolBotIsMoving Then
                    boolCollisionPredicted = True
                    ftnBotStop(ftnLocalizeUsingDeadReckoning(tbpBotPose, -0.2, timeMoveCommandSent, tbpStartingPose, tbpTargetPoseGlobal, strTypeOfMove, True), tbpTargetPoseGlobal)
                End If
            End If ' GotABotClass.InvokeRequired
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subCollisionPredicted")
        End Try
    End Sub


    '==================================== Add Image to Queue  =============================================
    Dim WithEvents classNewAddImageToQueue As classAddImageToQueue

    '==================================== Kinect  =============================================
    Dim WithEvents classNewKinect As classScanner

    '==================================== API Timeout  =============================================

    Dim boolAPIActivity1 As Boolean = True
    Dim boolAPIActivity2 As Boolean = True

    Public Sub subCheckForAPITimeout()
        Try
            subDoEventsIfMainThread()
            If classAPI1Server.Connected And Not boolAPIActivity1 Then
                intApiUncertainty = 9999
                modIF_Api1_Server.subAPITimeout()
                frmDebug.subWriteLogs(Color.DarkGray, " $$$$$$$$######################################## API 1 TIMEOUT = ")
                GotABotClass.subUpdateAllText(tbpBotPose)
            End If
            If classAPI2Server.Connected And Not boolAPIActivity2 Then
                intApiUncertainty = 9999
                modIF_Api2_Server.subAPITimeout()
                frmDebug.subWriteLogs(Color.DarkGray, " $$$$$$$$######################################## API 2 TIMEOUT = ")
                GotABotClass.subUpdateAllText(tbpBotPose)
            End If
            boolAPIActivity1 = False
            boolAPIActivity2 = False
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subCheckForAPITimeout")
        End Try
    End Sub



End Module
